function targets = C45_test(patterns, tree, discrete_dim)
indices = 1:size(patterns,2);
targets = zeros(1, size(patterns,2));

if (tree.dim == 0)
    targets(indices) = tree.child;
    return
end

dim = tree.dim;
dims= 1:size(patterns,1);
dims(dim)=[]; 
if (discrete_dim(dim) == 0)
    in				= indices(find(patterns(dim, indices) <= tree.split_loc));
    if isempty(dims)
        targets(in)=tree.child(1);
    else
        targets(in)	= C45_test(patterns(dims, in), tree.child(1), discrete_dim(dims));
    end
    in				= indices(find(patterns(dim, indices) >  tree.split_loc));
    if isempty(dims)
        targets(in)=tree.child(2);
    else
        targets(in)	= C45_test(patterns(dims,in), tree.child(2), discrete_dim(dims));
    end
else
    Uf				= unique(patterns(dim,:));
    for i = 1:length(Uf),
        in   	   = indices(find(patterns(dim, indices) == Uf(i)));
        if isempty(dims)
            targets(in)=tree.child(i);
        else
            targets(in)	= C45_test(patterns(dims, in), tree.child(i), discrete_dim(dims));
        end
    end
end