clc; clear;
load data;

train_patterns=Traindata'; 
train_patterns=train_patterns(1:4,:);  train_targets=Traindata(:,end)';

test_patterns=[
    7 1 1 1 2
    7 1 2 2 1
    7 3 1 2 2];

test_patterns=test_patterns(:,1:4)';
Fra_inc_node=0;
[Ni, M]		= size(train_patterns);
inc_node    = Fra_inc_node*M;
Nu          = 10;

discrete_dim = zeros(1,Ni);
for i = 1:Ni,
    Ub = unique(train_patterns(i,:));
    Nb = length(Ub);
    if (Nb <= Nu),
        discrete_dim(i)	= Nb;
        dist            = abs(ones(Nb ,1)*test_patterns(i,:) - Ub'*ones(1, size(test_patterns,2)));
        [m, in]         = min(dist);
        test_patterns(i,:)  = Ub(in);
    end
end

disp('Building a tree...')
tree            = C45_train(train_patterns, train_targets, inc_node, discrete_dim)

disp('Classify test samples using the tree...')
test_targets    =  C45_test(test_patterns, tree, discrete_dim)